﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Editor
{
    class SingVar
    {
        public static string C_REG_ADR = "SOFTWARE\\WILHELM\\Mustereditor";

        private int iTabLength = 20;  // Pixel
        private bool bWordWrap = false;

        private int iTop = 0;
        private int iLeft = 0;
        private int iWidth = 800;
        private int iHeight = 600;
        private bool bSetting = false;

        private static SingVar instance = new SingVar();


        public static SingVar getInstance()
        {
            return instance;
        }

        private SingVar()
        {
            iTabLength = basis.ReadRegInt(C_REG_ADR, "iTabLength");
            if (iTabLength < 5) iTabLength = 5;

            bWordWrap = basis.ReadRegBool(C_REG_ADR, "bWordWrap");

            bSetting = basis.ReadRegBool(C_REG_ADR, "bSetting");
            iTop = basis.ReadRegInt(C_REG_ADR, "iTop");
            iLeft = basis.ReadRegInt(C_REG_ADR, "iLeft");
            iWidth = basis.ReadRegInt(C_REG_ADR, "iWidth");
            iHeight = basis.ReadRegInt(C_REG_ADR, "iHeight");

        }



        public bool Setting
        {
            get { return bSetting; }
            set
            {
                bSetting = value;
                basis.WriteRegBool(C_REG_ADR, "bSetting", bSetting);
            }
        }


        public int TabLength
        {
            get { return iTabLength; }
            set
            {
                iTabLength = value;
                basis.WriteRegInt(C_REG_ADR, "iTabLength", iTabLength);
            }
        }


        public bool WordWrap
        {
            get { return bWordWrap; }
            set
            {
                bWordWrap = value;
                basis.WriteRegBool(C_REG_ADR, "bWordWrap", bWordWrap);
            }
        }




        public int Top
        {
            get { return iTop; }
            set
            {
                iTop = value;
                basis.WriteRegInt(C_REG_ADR, "iTop", iTop);
            }
        }


        public int Left
        {
            get { return iLeft; }
            set
            {
                iLeft = value;
                basis.WriteRegInt(C_REG_ADR, "iLeft", iLeft);
            }
        }


        public int Width
        {
            get { return iWidth; }
            set
            {
                iWidth = value;
                basis.WriteRegInt(C_REG_ADR, "iWidth", iWidth);
            }
        }


        public int Height
        {
            get { return iHeight; }
            set
            {
                iHeight = value;
                basis.WriteRegInt(C_REG_ADR, "iHeight", iHeight);
            }
        }

    }
}
